'From Squeak3.9alpha of 4 July 2005 [latest update: #7032] on 15 June 2006 at 2:02:23 pm'!
Object subclass: #Customer
	instanceVariableNames: 'name'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostOffice'!
Object subclass: #PostOffice
	instanceVariableNames: 'queue counters serving'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostOffice'!
TestCase subclass: #PostOfficeTest
	instanceVariableNames: 'postoffice'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PostOffice'!

!Customer methodsFor: 'initialization' stamp: 'on 6/15/2006 13:50'!
named: aByteString 
	name := aByteString.! !

!Customer methodsFor: 'accessing' stamp: 'on 6/15/2006 13:58'!
name
	^ name! !


!Customer class methodsFor: 'creation' stamp: 'on 6/15/2006 13:49'!
named: aByteString 
	^ self new named: aByteString! !


!PostOffice methodsFor: 'evaluating' stamp: 'on 6/15/2006 13:54'!
enter: aCustomer 
	queue addLast: aCustomer.! !

!PostOffice methodsFor: 'evaluating' stamp: 'on 6/15/2006 13:59'!
serve
	| customer |
	customer := queue removeFirst.
	Transcript show:
		'Counter ', serving asString, ' serving ', customer name; cr.
	self switchServing.
	^ customer name! !

!PostOffice methodsFor: 'evaluating' stamp: 'on 6/15/2006 13:53'!
switchServing
	serving := serving \\ counters + 1.! !

!PostOffice methodsFor: 'initialize-release' stamp: 'on 6/15/2006 13:52'!
initialize
	queue := OrderedCollection new.
	counters := 2.
	serving := 1.! !

!PostOffice methodsFor: 'testing' stamp: 'on 6/15/2006 13:55'!
waiting
	^ queue size! !


!PostOfficeTest methodsFor: 'running' stamp: 'on 6/15/2006 13:48'!
setUp
	postoffice := PostOffice new.! !

!PostOfficeTest methodsFor: 'running' stamp: 'on 6/15/2006 13:57'!
testPostOffice
	postoffice enter: (Customer named: 'jack').
	self assert: postoffice waiting = 1.
	postoffice enter: (Customer named: 'jane').
	self assert: postoffice waiting = 2.
	postoffice enter: (Customer named: 'jill').
	self assert: postoffice waiting = 3.
	self assert: postoffice serve = 'jack'.
	self assert: postoffice waiting = 2.
	self assert: postoffice serve = 'jane'.
	self assert: postoffice waiting = 1.
	self assert: postoffice serve = 'jill'.
	self assert: postoffice waiting = 0.! !


!PostOfficeTest reorganize!
('running' setUp testPostOffice)
!


!PostOffice reorganize!
('evaluating' enter: serve switchServing)
('initialize-release' initialize)
('testing' waiting)
!


!Customer reorganize!
('initialization' named:)
('accessing' name)
!

