/**
 * Are private methods inherited?
 * What happens when a subclass overrides inherited
 * private methods used by other, inherited methods?
 **/
class Puzzle1 extends AbstractPuzzle {
	class A {
		public void m() { this.p(); }
		private void p() { System.out.println("A.p()"); }
	}

	class B extends A {
		private void p() { println("B.p()"); }
	}

	/**
	 * Evaluate: (new Puzzle1()).run();
	 **/
	void run() {
		super.run();

		A b = new B();
		b.m(); // What is printed? A.p() or B.p()?
	}	
}
