/**
 * How does java decide which overloaded method to
 * call when the argument types overlap?
 * Does java consider the declared type or the
 * run-time type of the arguments?
 *<P>
 * What happens if we comment out m(A,A)? m(B,B)? m(A,B)?
 * In which cases will the example still compile?
 * Where it does compile, which methods will be called?
 **/
class Puzzle2 extends AbstractPuzzle {

	class A { }
	class B extends A { }

	// What happens if we comment out some of these?

	void m(A a1, A a2) { println("m(A,A)"); };
	void m(A a1, B b1) { println("m(A,B)"); };
	void m(B b1, A a1) { println("m(B,A)"); };
	void m(B b1, B b2) { println("m(B,B)"); };
	
	/**
	 * Evaluate: (new Puzzle2()).run();
	 **/
	void run() {
		super.run();

		B b = new B();
		A a = b;
		// The arguments objects are the same in each call!
		// Which methods will actually be called?
		m(a, a);
		m(a, b);
		m(b, a);
		m(b, b);
	}	
}