package p2.tictactoe;

/**
 * Test cases for TicTacToe.
 * @author $Author: oscar $
 * @version $Id: TicTacToeTest.java,v 1.5 2005/02/22 15:08:04 oscar Exp $
 */
public class TicTacToeTest extends AbstractBoardGameTest {
	public TicTacToeTest(String name) { super(name); }

	public static void main(String[] args) {
		junit.awtui.TestRunner.run(TicTacToeTest.class);
	}
	
	/**
	 * Test the getters and setters.
	 */
	public void testState() {
		game = makeGame(new Player('X'), new Player('O'));
		assertEquals(game.get(0,0), ' ');
		assertEquals(game.get(2,2), ' ');
		((TicTacToe) game).set(2,2,'X');
		assertEquals(game.get(2,2), 'X');
		((TicTacToe) game).set(2,2,' ');
		assertEquals(game.get(2,2), ' ');
		assertFalse(game.inRange(3,3));
	}
	
	public void testXWinDiagonal() {
		checkGame("a1\nb2\nc3\n", "b1\nc1\n", "X", 4);
	}

	public void testNoWinner() {
		checkGame("b2\na1\nb3\na2\nc1\n",
				"a3\nc3\nb1\nc2\n", "nobody",0);
	}
	
	public void testOWinReverseDiagonal() {
		checkGame("a1\nb1\n"
				+ "a1\nb1\nb2\nc1\nd0\nxxx\n\n" // invalid moves
				+ "a2\n",
				"b2\nc1\na3\n", "O", 3);
	}
	
	public void testXWinCentreColumn() {
		checkGame("b2\nb1\nb3\n",
				"a1\n"
				+ "b1\nA0\n" // invalid moves
				+ "a3\n", "X", 4);
	}
	
	public void testOWinTopRow() {
		checkGame("b2\na1\nc1\n",
				"a3\nc3\nb3\n", "O", 3);
	}
	
	protected BoardGame makeGame(Player X, Player O) {
		return new TicTacToe(X, O);
	}
}
