package p2.tictactoe.gui;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

/**
 * This class provides a button to instantiate
 * a TicTacToe GameGUI.
 *
 * @author $Author: oscar $
 * @version $Id: GameApplet.java,v 1.1 2005/02/26 17:23:23 oscar Exp $
 */
public class GameApplet extends Applet
{
	private final String imageDir = "p2/tictactoe/gui/images/";
	
	/**
	 * Instantiates the BoardGame, initializes the view components,
	 * and connects the view to the model.
	 */
	public void init() {
		setLayout(new FlowLayout());
		this.add(makeControls());
	}
	
	/**
	 * Make a Button to instantiate a TicTacToe GameGUI.
	 * Need another Button for Gomoku?
	 */
	private Component makeControls() {
		Panel controls = new Panel();
		controls.setLayout(new FlowLayout());
		
		Button again = new Button("New game");
		again.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				// NB: anonymous inner class has access to
				// methods of enclosing class (GameApplet)
				showStatus("starting new game ...");
				GameGUI gui = new GameGUI("TicTacToe Applet", getImages());
				gui.setVisible(true);
			}
		});
		controls.add(again);
		return controls;
	}
	
	/**
	 * Get the X and O images relative to this Applet.
	 */
	private Image[] getImages() {
		Image[] images = new Image[3];
		images[0] = getImage(getCodeBase(), imageDir + "cross.gif");
		images[1] = getImage(getCodeBase(), imageDir + "not.gif");
		images[2] = getImage(getCodeBase(), imageDir + "blank.gif");
		return images;
	}
}
