package p2.tictactoe;

/**
 * @author $Author: oscar $
 * @version $Id: GomokuTest.java,v 1.3 2005/03/02 14:32:34 oscar Exp $
 */
public class GomokuTest extends AbstractBoardGameTest {
	public GomokuTest(String name) { super(name); }

	public static void main(String[] args) {
		junit.awtui.TestRunner.run(GomokuTest.class);
	}
	
	protected void setUp() throws Exception {
		game = makeGame(new StreamPlayer('X'),
				new StreamPlayer('O'));
	}

	public void testOKinput() {
		String input = "a2";
		assertEquals(((Gomoku) game).getCol(input), 0);
		assertEquals(((Gomoku) game).getRow(input), 1);
		input = "b4";
		assertEquals(((Gomoku) game).getCol(input), 1);
		assertEquals(((Gomoku) game).getRow(input), 3);
		input = "c10";
		assertEquals(((Gomoku) game).getCol(input), 2);
		assertEquals(((Gomoku) game).getRow(input), 9);
	}

	public void testBadRow() {
		final String input = "aaa";
		assertEquals(((Gomoku) game).getCol(input), 0);
		assertFails(new Runnable() {
			public void run() {
				((Gomoku) game).getRow(input);
			}
		});
	}

	public void testEmptyInput() {
		final String input = "";
		assertFails(new Runnable() {
			public void run() {
				((Gomoku) game).getCol(input);
			}
		});
	}

	public void testBadCol() {
		final String input = "X10";
		assertFails(new Runnable() {
			public void run() {
				((Gomoku) game).getCol(input);
			}
		});
		assertEquals(((Gomoku) game).getRow(input), 9);
	}

	public void testXWinsDiagonal() {
		checkGame("\naa\n" // nonsense input
						+ "f6\ng5\ne7\nd8\nc9\n",
					"b2\nh4\nc3\nd4\n",
					"X", ((Gomoku)game).squares() - 9);
	}

	protected BoardGame makeGame(Player X, Player O) {
		return new Gomoku(X, O);
	}
}
