package p2.tictactoe.gui;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;

import p2.tictactoe.GameFactory;
import p2.tictactoe.TicTacToeFactory;

/**
 * This class provides a button to instantiate
 * a TicTacToe GameGUI.
 *
 * @author $Author: oscar $
 * @version $Id: GameApplet.java,v 1.4 2005/03/02 14:32:34 oscar Exp $
 */
public class GameApplet extends Applet
{
	private final String imageDir = "p2/tictactoe/gui/images/";
	
	/**
	 * Instantiates the BoardGame, initializes the view components,
	 * and connects the view to the model.
	 */
	public void init() {
		setLayout(new FlowLayout());
		this.add(makeControls());
	}
	
	/**
	 * Make a Button to instantiate a TicTacToe GameGUI.
	 * Need another Button for Gomoku?
	 */
	private Component makeControls() {
		Panel controls = new Panel();
		controls.setLayout(new FlowLayout());
		final GameFactory factory_ = new TicTacToeFactory();
		
		Button again = new Button("New game");
		again.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				showStatus("starting new game ...");
				GameGUI gui = new GameGUI(factory_.getGame());
				gui.setVisible(true);
			}
		});
		controls.add(again);
		return controls;
	}
}
