package p2.tictactoe.gui;

import java.awt.*;
import java.awt.event.*;
import p2.tictactoe.*;

/**
 * Top-level frame with buttons to start TicTacToe or Gomoku.
 * @author $Author: oscar $
 * @version $Id: GameConsole.java,v 1.2 2005/03/02 14:32:34 oscar Exp $
 */
public class GameConsole extends Frame {
	GameFactory tictactoeFactory_, gomokuFactory_;
	
	public GameConsole(String title) throws HeadlessException {
		super(title);
		tictactoeFactory_ = new TicTacToeFactory();
		gomokuFactory_ = new GomokuFactory();
		setLayout(new FlowLayout());
		add(makeTicTacToe());
		add(makeGomoku());
		this.setVisible(true);
		this.pack();
	}
	
	public static void main(String[] args) {
		new GameConsole("TicTacToe/Gomoku Console");
	}
	
	private Button makeTicTacToe() {
		Button button = new Button("Start TicTacToe");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				(new GameGUI(tictactoeFactory_.getGame())).setVisible(true);
			}
		});
		return button;
	}

	private Button makeGomoku() {
		Button button = new Button("Start Gomoku");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				(new GameGUI(gomokuFactory_.getGame())).setVisible(true);
			}
		});
		return button;
	}
}
