package p2.tictactoe;

/**
 * Tests the outcome of various scripted Gomoku games
 * @author $Author: oscar $
 * @version $Id: GomokuTest.java,v 1.5 2005/03/10 15:28:25 oscar Exp $
 */
public class GomokuTest extends AbstractBoardGameTest {
	public GomokuTest(String name) { super(name); }
	
	public static void main(String[] args) {
		junit.awtui.TestRunner.run(GomokuTest.class);
	}
	
	protected void setUp() throws Exception {
		game = makeGame(new StreamPlayer('X'),
				new StreamPlayer('O'));
	}
	
	public void testOKinput() {
		String input = "a2";
		assertEquals(((Gomoku) game).getCol(input), 0);
		assertEquals(((Gomoku) game).getRow(input), 1);
		input = "b4";
		assertEquals(((Gomoku) game).getCol(input), 1);
		assertEquals(((Gomoku) game).getRow(input), 3);
		input = "c10";
		assertEquals(((Gomoku) game).getCol(input), 2);
		assertEquals(((Gomoku) game).getRow(input), 9);
	}
	
	public void testBadRow() {
		final String input = "aaa";
		assertEquals(((Gomoku) game).getCol(input), 0);
		try {
			((Gomoku) game).getRow(input);
			fail();
		} catch (AssertionError err) { }
	}
	
	public void testEmptyInput() {
		final String input = "";
		try {
			((Gomoku) game).getCol(input);
			fail();
		} catch (AssertionError err) { }
	}
	
	
	public void testBadCol() {
		final String input = "X10";
		try {
			((Gomoku) game).getCol(input);
			fail();
		} catch (AssertionError err) { }
		
		assertEquals(((Gomoku) game).getRow(input), 9);
	}
	
	public void testXWinsDiagonal() {
		checkGame("\naa\n" // nonsense input
				+ "f6\ng5\ne7\nd8\nc9\n",
				"b2\nh4\nc3\nd4\n",
				"X", ((Gomoku)game).squares() - 9);
	}
	
	protected BoardGame makeGame(Player X, Player O) {
		return new Gomoku(X, O);
	}
}
