package p2.tictactoe.gui;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.rmi.Naming;
import java.rmi.RMISecurityManager;
import java.rmi.RemoteException;

import p2.tictactoe.rmi.RemoteGameServer;
/*
import java.awt.event.*;

import p2.tictactoe.GameFactory;
import p2.tictactoe.TicTacToeFactory;
*/

/**
 * This class provides a button to instantiate
 * a TicTacToe GameGUI.
 *
 * @author $Author: oscar $
 * @version $Id: GameApplet.java,v 1.5 2005/03/03 14:18:13 oscar Exp $
 */
public class GameApplet extends Applet
{
	private final String imageDir = "p2/tictactoe/gui/images/";
	
	/**
	 * Instantiates the BoardGame, initializes the view components,
	 * and connects the view to the model.
	 */
	public void init() {
		setLayout(new FlowLayout());
		this.add(makeControls());
	}
	
	/**
	 * Make a Button to instantiate a TicTacToe GameGUI.
	 * Need another Button for Gomoku?
	 */
	private Component makeControls() {
		Panel controls = new Panel();
		controls.setLayout(new FlowLayout());
		controls.add(makeTicTacToe());
		return controls;
	}

	private Button makeTicTacToe() {
		Button button = new Button("Start TicTacToe");
		button.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				try {
					(new GameGUI(connectToServer().joinTicTacToe())).setVisible(true);
				} catch (HeadlessException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				} catch (RemoteException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		});
		return button;
	}

	/**
	 * Get a remote GameServer through an RMI registry.
	 */
	private RemoteGameServer connectToServer()
	{
		if (System.getSecurityManager() == null) {
			System.setSecurityManager(new RMISecurityManager());
			System.out.println("Set new Security manager");
		} else {
			System.out.println("Security manager already set");
		}
		RemoteGameServer server = null;

		String host = getParameter("host");
		if (host.equals("")) {
			System.err.println("Missing host parameter in <APPLET> tag");
			showStatus("Missing host parameter in <APPLET> tag");
		}
		String name = "//" + host + "/GameServer";
		try {
				System.err.println("Looking up " + name + "...");
				server = (RemoteGameServer) Naming.lookup(name);
				System.err.println("Lookup succeeded!");
			} catch (Exception e) {
				System.err.println("Naming.lookup(" + name + ") failed");
				System.err.println("GameApplet exception: " + e.getMessage());
				e.printStackTrace();
			}
		return server;
	}
}
