package p2.junit.v3;

import java.util.Hashtable;
import java.util.Enumeration;

class MoneyBag implements IMoney {
	private Hashtable fMonies= new Hashtable(5);

	MoneyBag(Money m1, Money m2) {
		appendMoney(m1);
		appendMoney(m2);
	}

	MoneyBag(Money bag[]) {
		for (int i= 0; i < bag.length; i++)
			appendMoney(bag[i]);
	}

	MoneyBag(Money m, MoneyBag bag) {
		appendMoney(m);
		appendBag(bag);
	}

	MoneyBag(MoneyBag m1, MoneyBag m2) {
		appendBag(m1);
		appendBag(m2);
	}

	public IMoney add(IMoney m) {
		return m.addMoneyBag(this);
	}

	public IMoney addMoney(Money m) {
		return new MoneyBag(m, this);
	}

	public IMoney addMoneyBag(MoneyBag s) {
		return new MoneyBag(s, this);
	}

	private void appendMoney(Money aMoney) {
		IMoney m = (IMoney) fMonies.get(aMoney.currency());
		if (m != null)
			m = m.add(aMoney);
		else
			m = aMoney;
		fMonies.put(aMoney.currency(), m);
	}

	private void appendBag(MoneyBag aBag) {
		for (Enumeration e= aBag.fMonies.elements(); e.hasMoreElements(); )
			appendMoney((Money)e.nextElement());
	}
}
